## xrootd 5.7.3

=== CMakeLists.txt ===
#-------------------------------------------------------------------------------
# Project description
#-------------------------------------------------------------------------------
cmake_minimum_required(VERSION 3.16...3.30 FATAL_ERROR)

project( XRootD )

set( CMAKE_MODULE_PATH
 ${PROJECT_SOURCE_DIR}/src
 ${PROJECT_SOURCE_DIR}/cmake )

include(XRootDVersion)

#-------------------------------------------------------------------------------
# A 'plugins' phony target to simplify building build-tree binaries.
# Plugins are responsible for adding themselves to this target, where
# appropriate.
#-------------------------------------------------------------------------------
ADD_CUSTOM_TARGET(plugins)


include( XRootDUtils )
CheckBuildDirectory()

include( XRootDOSDefs )
include( XRootDDefaults )
include( XRootDSystemCheck )
include( XRootDFindLibs )

add_definitions( -DXRDPLUGIN_SOVERSION="${PLUGIN_VERSION}" )

#-------------------------------------------------------------------------------
# Generate the version header
#-------------------------------------------------------------------------------

configure_file(src/XrdVersion.hh.in src/XrdVersion.hh)

#-------------------------------------------------------------------------------
# Build in subdirectories
#-------------------------------------------------------------------------------

include_directories(BEFORE ${CMAKE_SOURCE_DIR}/src ${CMAKE_BINARY_DIR}/src)

include(CTest)

add_subdirectory(src)
add_subdirectory(bindings)
add_subdirectory(tests)

add_subdirectory(docs)
add_subdirectory(utils)

include( XRootDSummary )


#-------------------------------------------------------------------------------
# Install XRootDConfig.cmake module
#-------------------------------------------------------------------------------

include(CMakePackageConfigHelpers)

write_basic_package_version_file(cmake/${PROJECT_NAME}ConfigVersion.cmake
  VERSION ${XRootD_VERSION} COMPATIBILITY SameMajorVersion)

configure_package_config_file(cmake/${PROJECT_NAME}Config.cmake.in cmake/${PROJECT_NAME}Config.cmake
  INSTALL_PREFIX
    ${CMAKE_INSTALL_PREFIX}
  INSTALL_DESTINATION
    ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}
  PATH_VARS
    CMAKE_INSTALL_INCLUDEDIR
    CMAKE_INSTALL_LIBDIR
    CMAKE_INSTALL_DATADIR
)

install(DIRECTORY ${PROJECT_BINARY_DIR}/cmake/
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME})

#-------------------------------------------------------------------------------
# Configure an 'uninstall' target
#-------------------------------------------------------------------------------
CONFIGURE_FILE(
	"${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
	"${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
	IMMEDIATE @ONLY)

ADD_CUSTOM_TARGET(uninstall
  "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

=== src/CMakeLists.txt ===
#-------------------------------------------------------------------------------
# If this is a build for pip set up the rpath
# (this is especially important for plugins)
#-------------------------------------------------------------------------------
if( PYPI_BUILD )
  set( CMAKE_INSTALL_RPATH "$ORIGIN" )
  set( CMAKE_INSTALL_RPATH_USE_LINK_PATH true )
endif()

#-------------------------------------------------------------------------------
# XRDCL_LIB_ONLY implies XRDCL_ONLY
#-------------------------------------------------------------------------------
if( XRDCL_LIB_ONLY )
  set ( XRDCL_ONLY TRUE )
endif()

#-------------------------------------------------------------------------------
# Include the subcomponents
#-------------------------------------------------------------------------------
include( XrdUtils )
include( XrdApps )
include( XrdCrypto )
include( XrdPosix )
include( XrdSec )
include( XrdXml )
include( XrdHeaders )
include( XrdSecgsi )
include( XrdSecztn )

if( BUILD_KRB5 )
  include( XrdSeckrb5 )
endif()

if( BUILD_XRDEC )
  include( XrdIsal )
endif()

if( ENABLE_XRDCL )
  add_subdirectory( XrdCl )
endif()

if( BUILD_XRDCLHTTP )
  add_subdirectory( XrdClHttp )
endif()

if( BUILD_XRDEC )
  add_subdirectory( XrdEc )
endif()

if( NOT XRDCL_ONLY )
  include( XrdServer )
  include( XrdDaemons )
  include( XrdFrm )
  include( XrdFfs )
  include( XrdPlugins )
  include( XrdSsi )
  include( XrdPfc )
  include( XrdOssCsi )

  if( BUILD_HTTP )
    include( XrdHttp )
    include( XrdTpc )
  endif()

  if( BUILD_MACAROONS )
    include( XrdMacaroons )
  endif()

  if( BUILD_VOMS )
    include( XrdVoms )
  endif()

  add_subdirectory( XrdCeph )

  if( BUILD_SCITOKENS )
    include( XrdSciTokens )
  endif()

endif()

=== tests/CMakeLists.txt ===
if(NOT BUILD_TESTS)
  return()
endif()

include(GoogleTest)

add_subdirectory(common)

add_subdirectory(XrdCl)
add_subdirectory(XrdCeph)
add_subdirectory(XrdEc)

add_subdirectory(XrdHttpTests)

add_subdirectory(XrdOucTests)

add_subdirectory( XrdSsiTests )

add_subdirectory(XrdTpcTests)

if( BUILD_SCITOKENS )
  add_subdirectory( scitokens )
endif()

if(NOT ENABLE_SERVER_TESTS)
  return()
endif()

add_subdirectory( XRootD )
add_subdirectory( cluster )

=== utils/CMakeLists.txt ===
if( NOT XRDCL_LIB_ONLY )
  configure_file(xrootd-config xrootd-config @ONLY)
  install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/xrootd-config DESTINATION ${CMAKE_INSTALL_BINDIR})
endif()

if( NOT XRDCL_ONLY )
  install(PROGRAMS
    ${CMAKE_SOURCE_DIR}/utils/XrdCmsNotify.pm
    ${CMAKE_SOURCE_DIR}/utils/netchk
    ${CMAKE_SOURCE_DIR}/utils/XrdOlbMonPerf
    ${CMAKE_SOURCE_DIR}/utils/cms_monPerf
    ${CMAKE_SOURCE_DIR}/utils/xrdcp-tpc.sh
    DESTINATION ${CMAKE_INSTALL_DATADIR}/xrootd/utils)
endif()

=== bindings/python/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16...3.30 FATAL_ERROR)

project(PyXRootD LANGUAGES CXX)

if( CMAKE_VERSION VERSION_LESS 3.18 )
  set(PYTHON_COMPONENTS Interpreter Development)
else()
  set(PYTHON_COMPONENTS Interpreter Development.Module)
endif()

find_package(Python REQUIRED COMPONENTS ${PYTHON_COMPONENTS})

if(CMAKE_SOURCE_DIR STREQUAL PROJECT_SOURCE_DIR OR PYPI_BUILD)
  add_subdirectory(src)
else()
  configure_file(setup.py setup.py)
  file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/VERSION "${XRootD_VERSION_STRING}")

  option(INSTALL_PYTHON_BINDINGS "Install Python bindings" TRUE)

  if(INSTALL_PYTHON_BINDINGS)
    set(PIP_OPTIONS "" CACHE STRING "Install options for pip")

    install(CODE "
      execute_process(COMMAND ${Python_EXECUTABLE} -m pip install ${PIP_OPTIONS}
        --prefix \$ENV{DESTDIR}${CMAKE_INSTALL_PREFIX} ${CMAKE_CURRENT_BINARY_DIR}
        RESULT_VARIABLE INSTALL_STATUS COMMAND_ECHO STDOUT)
      if(NOT INSTALL_STATUS EQUAL 0)
        message(FATAL_ERROR \"Failed to install Python bindings\")
      endif()
    ")
  endif()
endif()

=== src/XrdCeph/CMakeLists.txt ===
if(NOT ENABLE_CEPH)
  unset(BUILD_CEPH CACHE)
  return()
endif()

if(FORCE_ENABLED)
  find_package(ceph REQUIRED)
else()
  find_package(ceph)
  if(NOT CEPH_FOUND)
    unset(BUILD_CEPH CACHE)
    return()
  endif()
endif()

set(BUILD_CEPH TRUE CACHE BOOL INTERNAL FORCE)

add_library(XrdCephPosix SHARED
  XrdCephPosix.cc XrdCephPosix.hh)

target_compile_options(XrdCephPosix
  PRIVATE -Wno-deprecated-declarations)

target_link_libraries(XrdCephPosix
  PRIVATE XrdUtils ${RADOS_LIBS})

target_include_directories(XrdCephPosix
  PUBLIC ${RADOS_INCLUDE_DIR} $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/src>)

set_target_properties(XrdCephPosix
  PROPERTIES VERSION 0.0.1 SOVERSION 0)

set(LIB_XRD_CEPH XrdCeph-${PLUGIN_VERSION})

add_library(${LIB_XRD_CEPH} MODULE
  XrdCephOss.cc     XrdCephOss.hh
  XrdCephOssFile.cc XrdCephOssFile.hh
  XrdCephOssDir.cc  XrdCephOssDir.hh)

target_link_libraries(${LIB_XRD_CEPH}
  PRIVATE ${XROOTD_LIBRARIES} XrdCephPosix)

set(LIB_XRD_CEPH_XATTR XrdCephXattr-${PLUGIN_VERSION})

add_library(${LIB_XRD_CEPH_XATTR} MODULE
  XrdCephXAttr.cc XrdCephXAttr.hh)

target_link_libraries(${LIB_XRD_CEPH_XATTR}
  PRIVATE ${XROOTD_LIBRARIES} XrdCephPosix)

install(TARGETS XrdCephPosix ${LIB_XRD_CEPH} ${LIB_XRD_CEPH_XATTR}
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})

=== src/XrdCl/CMakeLists.txt ===


#-------------------------------------------------------------------------------
# Shared library version
#-------------------------------------------------------------------------------
set( XRD_CL_VERSION   3.0.0 )
set( XRD_CL_SOVERSION 3 )

#-------------------------------------------------------------------------------
# The XrdCl Pipelining API
#-------------------------------------------------------------------------------
set( XrdClPipelineSources
     XrdClOperations.cc            XrdClOperations.hh
     XrdClOperationHandlers.hh
     XrdClArg.hh
     XrdClFwd.hh
     XrdClParallelOperation.hh
     XrdClFileOperations.hh
     XrdClFileSystemOperations.hh
     XrdClZipOperations.hh
)

#-------------------------------------------------------------------------------
# XrdEc sources
#-------------------------------------------------------------------------------
if( BUILD_XRDEC )
  set( XrdEcSources
       ${CMAKE_SOURCE_DIR}/src/XrdEc/XrdEcRedundancyProvider.cc
       ${CMAKE_SOURCE_DIR}/src/XrdEc/XrdEcUtilities.cc
       ${CMAKE_SOURCE_DIR}/src/XrdEc/XrdEcStrmWriter.cc
       ${CMAKE_SOURCE_DIR}/src/XrdEc/XrdEcReader.cc
       XrdClEcHandler.cc
  )
  add_compile_definitions( WITH_XRDEC )
endif()

#-------------------------------------------------------------------------------
# The XrdCl lib
#-------------------------------------------------------------------------------
add_library(
  XrdCl
  SHARED
  XrdClLog.cc                    XrdClLog.hh
  XrdClUtils.cc                  XrdClUtils.hh
                                 XrdClOptimizers.hh
                                 XrdClConstants.hh
  XrdClEnv.cc                    XrdClEnv.hh
  XrdClDefaultEnv.cc             XrdClDefaultEnv.hh
  XrdClURL.cc                    XrdClURL.hh
  XrdClStatus.cc                 XrdClStatus.hh
  XrdClSocket.cc                 XrdClSocket.hh
  XrdClTls.cc                    XrdClTls.hh
                                 XrdClPoller.hh
  XrdClPollerFactory.cc          XrdClPollerFactory.hh
  XrdClPollerBuiltIn.cc          XrdClPollerBuiltIn.hh
  XrdClPostMaster.cc             XrdClPostMaster.hh
                                 XrdClPostMasterInterfaces.hh
  XrdClChannel.cc                XrdClChannel.hh
  XrdClStream.cc                 XrdClStream.hh
  XrdClXRootDTransport.cc        XrdClXRootDTransport.hh
  XrdClInQueue.cc                XrdClInQueue.hh
  XrdClOutQueue.cc               XrdClOutQueue.hh
  XrdClTaskManager.cc            XrdClTaskManager.hh
  XrdClSIDManager.cc             XrdClSIDManager.hh
  XrdClFileSystem.cc             XrdClFileSystem.hh
  XrdClXRootDMsgHandler.cc       XrdClXRootDMsgHandler.hh
                                 XrdClBuffer.hh
                                 XrdClMessage.hh
  XrdClMessageUtils.cc           XrdClMessageUtils.hh
  XrdClXRootDResponses.cc        XrdClXRootDResponses.hh
                                 XrdClRequestSync.hh
  XrdClFile.cc                   XrdClFile.hh
  XrdClFileStateHandler.cc       XrdClFileStateHandler.hh
  XrdClCopyProcess.cc            XrdClCopyProcess.hh
  XrdClClassicCopyJob.cc         XrdClClassicCopyJob.hh
  XrdClThirdPartyCopyJob.cc      XrdClThirdPartyCopyJob.hh
  XrdClAsyncSocketHandler.cc     XrdClAsyncSocketHandler.hh
  XrdClChannelHandlerList.cc     XrdClChannelHandlerList.hh
  XrdClForkHandler.cc            XrdClForkHandler.hh
  XrdClCheckSumManager.cc        XrdClCheckSumManager.hh
  XrdClTransportManager.cc       XrdClTransportManager.hh
                                 XrdClSyncQueue.hh
  XrdClJobManager.cc             XrdClJobManager.hh
                                 XrdClResponseJob.hh
  XrdClFileTimer.cc              XrdClFileTimer.hh
                                 XrdClPlugInInterface.hh
  XrdClPlugInManager.cc          XrdClPlugInManager.hh
                                 XrdClPropertyList.hh
                                 XrdClCopyJob.hh
  XrdClFileSystemUtils.cc        XrdClFileSystemUtils.hh
  XrdClTPFallBackCopyJob.cc      XrdClTPFallBackCopyJob.hh
  XrdClMetalinkRedirector.cc     XrdClMetalinkRedirector.hh
  XrdClRedirectorRegistry.cc     XrdClRedirectorRegistry.hh
  XrdClXCpCtx.cc                 XrdClXCpCtx.hh
  XrdClXCpSrc.cc                 XrdClXCpSrc.hh
  XrdClLocalFileHandler.cc       XrdClLocalFileHandler.hh
  XrdClLocalFileTask.cc          XrdClLocalFileTask.hh
  XrdClZipListHandler.cc         XrdClZipListHandler.hh
  XrdClZipArchive.cc             XrdClZipArchive.hh
  
  ${XrdClPipelineSources}

  ${XrdEcSources}
)

target_link_libraries(
  XrdCl
  PRIVATE
  XrdXml
  XrdUtils
  uuid::uuid
  ZLIB::ZLIB
  OpenSSL::SSL
  ${CMAKE_THREAD_LIBS_INIT}
  ${EXTRA_LIBS}
  ${CMAKE_DL_LIBS})

set_target_properties(
  XrdCl
  PROPERTIES
  VERSION   ${XRD_CL_VERSION}
  SOVERSION ${XRD_CL_SOVERSION} )

if( BUILD_XRDEC )
  target_include_directories(XrdCl PUBLIC ${ISAL_INCLUDE_DIRS})
  target_link_libraries(XrdCl PRIVATE ${ISAL_LIBRARIES})
endif()

#-------------------------------------------------------------------------------
# xrdfs
#-------------------------------------------------------------------------------
if( NOT XRDCL_LIB_ONLY )
add_executable(
  xrdfs
  XrdClFS.cc
  XrdClFSExecutor.cc         XrdClFSExecutor.hh )

target_link_libraries(
  xrdfs
  ${CMAKE_THREAD_LIBS_INIT}
  XrdCl
  XrdUtils
  ${READLINE_LIBRARY}
  ${NCURSES_LIBRARY} )

if( READLINE_FOUND )
  target_include_directories(xrdfs PRIVATE ${READLINE_INCLUDE_DIR})
endif()
endif()

#-------------------------------------------------------------------------------
# xrdcopy
#-------------------------------------------------------------------------------
if( NOT XRDCL_LIB_ONLY )
add_executable(
  xrdcp
  XrdClCopy.cc )

target_link_libraries(
  xrdcp
  XrdCl
  XrdUtils
  XrdAppUtils )
endif()

#-------------------------------------------------------------------------------
# Install
#-------------------------------------------------------------------------------
install(
  TARGETS XrdCl
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} )

if( NOT XRDCL_LIB_ONLY )
install(
  TARGETS xrdfs xrdcp
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} )
endif()

install(
  FILES
    XrdClAnyObject.hh
    XrdClBuffer.hh
    XrdClConstants.hh
    XrdClCopyProcess.hh
    XrdClDefaultEnv.hh
    XrdClEnv.hh
    XrdClFile.hh
    XrdClFileSystem.hh
    XrdClFileSystemUtils.hh
    XrdClMonitor.hh
    XrdClStatus.hh
    XrdClURL.hh
    XrdClXRootDResponses.hh
    XrdClOptional.hh
    XrdClPlugInInterface.hh
    XrdClPropertyList.hh
    XrdClLog.hh
  DESTINATION    ${CMAKE_INSTALL_INCLUDEDIR}/xrootd/XrdCl )
  
install(
  FILES
    # Additional client headers
    XrdClJobManager.hh
    XrdClMessage.hh
    XrdClPlugInManager.hh
    XrdClPostMaster.hh
    XrdClPostMasterInterfaces.hh
    XrdClTransportManager.hh
    XrdClResponseJob.hh
    XrdClSyncQueue.hh
    XrdClZipArchive.hh
    XrdClZipCache.hh
    # Declarative operations
    XrdClOperations.hh
    XrdClOperationHandlers.hh
    XrdClOperationTimeout.hh
    XrdClArg.hh
    XrdClCtx.hh
    XrdClFwd.hh
    XrdClParallelOperation.hh
    XrdClFileOperations.hh
    XrdClFileSystemOperations.hh
    XrdClFinalOperation.hh
    XrdClUtils.hh
    XrdClXRootDTransport.hh
    XrdClZipOperations.hh 
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/xrootd/private/XrdCl )

if( NOT XRDCL_LIB_ONLY )
install(
  CODE "
    EXECUTE_PROCESS(
      COMMAND ln -sf xrdcp xrdcopy
      WORKING_DIRECTORY \$ENV{DESTDIR}/${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_BINDIR} )"
)

endif()

=== tests/XRootD/CMakeLists.txt ===

list(APPEND XROOTD_CONFIGS noauth host unix sss)

if(ENABLE_FUSE_TESTS)
  list(APPEND XROOTD_CONFIGS fuse)
endif()

if(ENABLE_HTTP_TESTS)
  list(APPEND XROOTD_CONFIGS http)
endif()

# Note: HAVE_SCITOKEN_CONFIG_SET_STR is required to override the CA file
# for the scitokens library; otherwise, the test will fail with TLS errors.
if(BUILD_SCITOKENS AND HAVE_SCITOKEN_CONFIG_SET_STR)
  list(APPEND XROOTD_CONFIGS scitokens)
  list(APPEND scitokens_FIXTURES SciTokens)
endif()

foreach(CONFIG ${XROOTD_CONFIGS})
  add_test(NAME XRootD::${CONFIG}::setup
    COMMAND sh -c "${CMAKE_CURRENT_SOURCE_DIR}/test.sh ${CONFIG} setup")

  set_tests_properties(XRootD::${CONFIG}::setup
    PROPERTIES
      FIXTURES_SETUP XRootD::${CONFIG}
      ENVIRONMENT "BINARY_DIR=${CMAKE_BINARY_DIR}"
  )

  add_test(NAME XRootD::${CONFIG}::teardown
    COMMAND sh -c "${CMAKE_CURRENT_SOURCE_DIR}/test.sh ${CONFIG} teardown")

  set_tests_properties(XRootD::${CONFIG}::teardown
    PROPERTIES
      FIXTURES_CLEANUP XRootD::${CONFIG}
      ENVIRONMENT "BINARY_DIR=${CMAKE_BINARY_DIR}"
  )

  add_test(NAME XRootD::${CONFIG}::test
    COMMAND sh -c "${CMAKE_CURRENT_SOURCE_DIR}/test.sh ${CONFIG} run")

  list(APPEND ${CONFIG}_LOGS ${CMAKE_CURRENT_BINARY_DIR}/${CONFIG}/client.log)
  list(APPEND ${CONFIG}_LOGS ${CMAKE_CURRENT_BINARY_DIR}/${CONFIG}/xrootd.log)

  list(APPEND ${CONFIG}_FIXTURES XRootD::${CONFIG})

  set_tests_properties(XRootD::${CONFIG}::test
    PROPERTIES
      FIXTURES_REQUIRED "${${CONFIG}_FIXTURES}"
      ENVIRONMENT "BINARY_DIR=${CMAKE_BINARY_DIR}"
      ATTACHED_FILES_ON_FAIL "${${CONFIG}_LOGS}"
  )
endforeach()

if(BUILD_SCITOKENS AND HAVE_SCITOKEN_CONFIG_SET_STR)
  set_tests_properties(XRootD::scitokens::setup
    PROPERTIES
      FIXTURES_REQUIRED SciTokens
  )
endif()

=== tests/XrdCeph/CMakeLists.txt ===
if(NOT BUILD_CEPH)
  return()
endif()

add_executable(xrdceph-unit-tests XrdCeph.cc)

target_link_libraries(xrdceph-unit-tests
  XrdCephPosix GTest::GTest GTest::Main)

gtest_discover_tests(xrdceph-unit-tests TEST_PREFIX XrdCeph::)

=== tests/XrdEc/CMakeLists.txt ===
if(NOT BUILD_XRDEC)
  return()
endif()

add_executable(xrdec-unit-tests XrdEcTests.cc)

target_link_libraries(xrdec-unit-tests
  XrdEc XrdTestUtils GTest::GTest GTest::Main ${ISAL_LIBRARIES})

target_include_directories(xrdec-unit-tests PRIVATE ${ISAL_INCLUDE_DIRS})

gtest_discover_tests(xrdec-unit-tests TEST_PREFIX XrdEc::)

=== tests/XrdOucTests/CMakeLists.txt ===
add_executable(xrdoucutils-unit-tests XrdOucUtilsTests.cc)

target_link_libraries(xrdoucutils-unit-tests XrdUtils GTest::GTest GTest::Main)
target_include_directories(xrdoucutils-unit-tests PRIVATE ${CMAKE_SOURCE_DIR}/src)

gtest_discover_tests(xrdoucutils-unit-tests)

=== debian/changelog ===
xrootd (5.7.3-1) unstable; urgency=medium

  * Update to version 5.7.3
  * Drop patches accepted upstream
  * Build xrootd-ceph-plugins for loong64
  * Don't build libxrdec1 for 32 bit architectures

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Sat, 01 Feb 2025 09:00:18 +0100

=== debian/control ===
Source: xrootd
Section: net
Priority: optional
Standards-Version: 4.7.0
Build-Depends:
 debhelper-compat (= 13),
 dpkg-dev (>= 1.22.5),
 dh-python,
 cmake,
 pkgconf,
 libfuse-dev [linux-any kfreebsd-any],
 libkrb5-dev,
 libcurl4-openssl-dev,
 libtinyxml-dev,
 libxml2-dev,
 ncurses-dev,
 libssl-dev,
 libreadline-dev,
 zlib1g-dev,
 libsystemd-dev [linux-any],
 pybuild-plugin-pyproject,
 python3-dev,
 python3-pip,
 python3-setuptools,
 python3-wheel,
 libjson-c-dev,
 libmacaroons-dev,
 uuid-dev,
 voms-dev,
 libscitokens-dev,
 davix-dev,
 librados-dev [amd64 arm64 loong64 mips64el ppc64el riscv64 s390x],
 libradospp-dev [amd64 arm64 loong64 mips64el ppc64el riscv64 s390x],
 libradosstriper-dev [amd64 arm64 loong64 mips64el ppc64el riscv64 s390x],
 libisal-dev [amd64 arm64 mips64el ppc64el riscv64 s390x alpha hurd-amd64 loong64 ppc64 sparc64],
 attr,
 curl,
 davix,
 libgtest-dev,
 openssl,
 procps,
 uuid-runtime
Build-Depends-Indep:
 dh-sequence-sphinxdoc,
 doxygen,
 graphviz,
 python3-sphinx
Homepage: https://xrootd.web.cern.ch/
Maintainer: Mattias Ellert <mattias.ellert@physics.uu.se>
Vcs-Browser: https://salsa.debian.org/ellert/xrootd
Vcs-Git: https://salsa.debian.org/ellert/xrootd.git

Package: xrootd-server
Architecture: any
Multi-Arch: foreign
Depends:
 xrootd-plugins (= ${binary:Version}),
 xrootd-server-plugins (= ${binary:Version}),
 expect,
 logrotate,
 adduser,
 ${perl:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Description: Extended ROOT file server
 The Extended root file server consists of a file server called xrootd
 and a cluster management server called cmsd.
 .
 The xrootd server was developed for the root analysis framework to
 serve root files. However, the server is agnostic to file types and
 provides POSIX-like access to any type of file.
 .
 The cmsd server is the next generation version of the olbd server,
 originally developed to cluster and load balance Objectivity/DB AMS
 database servers. It provides enhanced capability along with lower
 latency and increased throughput.

Package: libxrdapputils2t64
Provides: ${t64:Provides}
Replaces: libxrdapputils2
Breaks: libxrdapputils2 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: Utilities library for xrootd applications
 This package contains the xrootd utilities library for applications.

Package: libxrdcrypto2t64
Provides: ${t64:Provides}
Replaces: libxrdcrypto2
Breaks: libxrdcrypto2 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: Cryptograpic library for xrootd
 This package contains the xrootd cryptograpic library.

Package: libxrdcryptolite2t64
Provides: ${t64:Provides}
Replaces: libxrdcryptolite2
Breaks: libxrdcryptolite2 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: Light version of cryptograpic library for xrootd
 This package contains the light version of the xrootd cryptograpic library.

Package: libxrdutils3t64
Provides: ${t64:Provides}
Replaces:
 libxrdutils3,
 libxrdcephposix0 [i386 armel armhf mips mipsel powerpc],
 xrootd-ceph-plugins [i386 armel armhf mips mipsel powerpc],
 libxrdec1t64 [armel armhf m68k sh4],
 libxrdec1 [armel armhf m68k sh4]
Breaks:
 libxrdutils3 (<< ${source:Version}),
 libxrdcephposix0 [i386 armel armhf mips mipsel powerpc],
 xrootd-ceph-plugins [i386 armel armhf mips mipsel powerpc],
 libxrdec1t64 [armel armhf m68k sh4],
 libxrdec1 [armel armhf m68k sh4]
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: Utilities library for xrootd
 This package contains the xrootd utilities library.

Package: libxrdxml3t64
Provides: ${t64:Provides}
Replaces: libxrdxml3
Breaks: libxrdxml3 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: XML library for xrootd
 This package contains the xrootd XML library.

Package: xrootd-plugins
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: Plugins used by xrootd servers and clients
 This package contains plugins used by the xrootd servers and clients.

Package: libxrootd-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 libxrdapputils2t64 (= ${binary:Version}),
 libxrdcrypto2t64 (= ${binary:Version}),
 libxrdcryptolite2t64 (= ${binary:Version}),
 libxrdutils3t64 (= ${binary:Version}),
 libxrdxml3t64 (= ${binary:Version}),
 ${misc:Depends}
Description: Development files for xrootd
 This package contains header files and development libraries for xrootd
 development.

Package: libxrdcl3t64
Provides: ${t64:Provides}
Replaces: libxrdcl3
Breaks: libxrdcl3 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Recommends:
 xrootd-plugins (= ${binary:Version}),
 xrootd-client-plugins(= ${binary:Version})
Description: Client library for xrootd
 This package contains the xrootd client library.

Package: libxrdec1t64
Provides: ${t64:Provides}
Replaces: libxrdec1
Breaks: libxrdec1 (<< ${source:Version})
Architecture: amd64 arm64 mips64el ppc64el riscv64 s390x alpha hurd-amd64 loong64 ppc64 sparc64
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: Erasure code library for xrootd
 This package contains the xrootd erasure code library.

Package: libxrdffs3t64
Provides: ${t64:Provides}
Replaces: libxrdffs3
Breaks: libxrdffs3 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: File protocol library for xrootd
 This package contains the xrootd file protocol library.

Package: libxrdposix3t64
Provides: ${t64:Provides}
Replaces: libxrdposix3
Breaks: libxrdposix3 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: Posix interface library for xrootd
 This package contains the xrootd Posix interface library.

Package: libxrdssilib2t64
Provides: ${t64:Provides}
Replaces: libxrdssilib2
Breaks: libxrdssilib2 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: Server internals library for xrootd
 This package contains an xrootd server internals library.

Package: libxrdssishmap2t64
Provides: ${t64:Provides}
Replaces: libxrdssishmap2
Breaks: libxrdssishmap2 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: Server internals library for xrootd
 This package contains an xrootd server internals library.

Package: xrootd-client-plugins
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: Plugins used by xrootd clients
 This package contains plugins used by xrootd clients.

Package: xrootd-client-http-plugins
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: HTTP client plugin for XRootD client
 This package contains an XRootD client plugin which allows XRootD to
 interact with HTTP repositories.

Package: libxrootd-client-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 libxrdcl3t64 (= ${binary:Version}),
 libxrdffs3t64 (= ${binary:Version}),
 libxrdposix3t64 (= ${binary:Version}),
 libxrootd-dev (= ${binary:Version}),
 ${misc:Depends}
Description: Development files for xrootd clients
 This package contains header files and development libraries for xrootd
 client development.

Package: libxrdhttputils2t64
Provides: ${t64:Provides}
Replaces: libxrdhttputils2
Breaks: libxrdhttputils2 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: HTTP protocol utilities library for xrootd
 This package contains the xrootd HTTP protocol utilities library.

Package: libxrdserver3t64
Provides: ${t64:Provides}
Replaces: libxrdserver3
Breaks: libxrdserver3 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Recommends:
 xrootd-plugins (= ${binary:Version}),
 xrootd-server-plugins(= ${binary:Version})
Description: Server library for xrootd
 This package contains the xrootd server library.

Package: xrootd-server-plugins
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: Plugins used by xrootd servers
 This package contains plugins used by xrootd servers.

Package: libxrootd-server-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 libxrdhttputils2t64 (= ${binary:Version}),
 libxrdserver3t64 (= ${binary:Version}),
 libxrootd-dev (= ${binary:Version}),
 libxrootd-client-dev (= ${binary:Version}),
 ${misc:Depends}
Description: Development files for xrootd servers
 This package contains header files and development libraries for xrootd
 server development.

Package: libxrootd-private-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 libxrdec1t64 (= ${binary:Version}) [amd64 arm64 mips64el ppc64el riscv64 s390x alpha hurd-amd64 loong64 ppc64 sparc64],
 libxrdssilib2t64 (= ${binary:Version}),
 libxrdssishmap2t64 (= ${binary:Version}),
 libxrootd-dev (= ${binary:Version}),
 libxrootd-client-dev (= ${binary:Version}),
 libxrootd-server-dev (= ${binary:Version}),
 ${misc:Depends}
Description: Private xrootd headers
 This package contains some private xrootd headers. Backward and forward
 compatibility between versions is not guaranteed for these headers.

Package: xrootd-client
Architecture: any
Multi-Arch: foreign
Depends:
 xrootd-plugins (= ${binary:Version}),
 xrootd-client-plugins(= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Description: Xrootd command line client tools
 This package contains the command line tools used to communicate with
 xrootd servers.

Package: xrootd-fuse
Architecture: linux-any kfreebsd-any
Multi-Arch: foreign
Depends:
 xrootd-plugins (= ${binary:Version}),
 xrootd-client-plugins (= ${binary:Version}),
 fuse3 (>= 3.10.1-3) | fuse (<< 3),
 ${shlibs:Depends},
 ${misc:Depends}
Description: Xrootd FUSE tool
 This package contains the FUSE (file system in user space) xrootd mount
 tool.

Package: xrootd-voms-plugins
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: VOMS attribute extractor plugin for XRootD
 This package contains the xrootd VOMS attribute extractor plugin.

Package: xrootd-scitokens-plugins
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: SciTokens authorization support for XRootD
 This ACC (authorization) plugin for the XRootD framework utilizes the
 SciTokens library to validate and extract authorization claims from a
 SciToken passed during a transfer. Configured appropriately, this
 allows the XRootD server admin to delegate authorization decisions for
 a subset of the namespace to an external issuer.

Package: libxrdcephposix0
Architecture: amd64 arm64 loong64 mips64el ppc64el riscv64 s390x
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: Ceph posix library for xrootd
 This package contains an xrootd library used by the ceph plugins.

Package: xrootd-ceph-plugins
Architecture: amd64 arm64 loong64 mips64el ppc64el riscv64 s390x
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: XRootD plugin for interfacing with the Ceph storage platform
 The xrootd-ceph is an OSS layer plugin for the XRootD server for
 interfacing with the Ceph storage platform.

Package: python3-xrootd
Architecture: any
Multi-Arch: foreign
Section: python
Provides:
 ${python3:Provides}
Depends:
 xrootd-plugins (= ${binary:Version}),

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Disable ceph dependent packages for architectures without ceph
# This list should match the Build-Depends on ceph libraries in debian/control
#
# Ceph requires boost-context and boost-coroutine
# These are only available on these Debian architectures:
#   i386 hurd-i386 amd64 hurd-amd64 armel armhf arm64 loong64
#   mips mipsel mips64el powerpc ppc64el riscv64 s390x
#
# Ceph requires Java
# Java is not available on these Debian architectures:
#   hppa hurd-i386 hurd-amd64
#
# Ceph only supports 64 bit architectures
ifneq ($(filter $(DEB_HOST_ARCH),amd64 arm64 loong64 mips64el ppc64el riscv64 s390x),)
CEPH = ON
else
CEPH = OFF
endif

ifneq ($(filter $(DEB_HOST_ARCH_OS),linux kfreebsd),)
FUSE = ON
else
FUSE = OFF
endif

ifneq ($(filter $(DEB_HOST_ARCH),amd64 arm64 mips64el ppc64el riscv64 s390x alpha hurd-amd64 loong64 ppc64 sparc64),)
EC = ON
else
EC = OFF
endif

export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

BUILD_DOC = $(if $(filter xrootd-doc,$(shell dh_listpackages)),TRUE,FALSE)

%:
	dh $@ --with python3 --buildsystem cmake

override_dh_auto_configure:
	dh_auto_configure -- \
	    -DFORCE_ENABLED:BOOL=ON \
	    -DENABLE_TESTS:BOOL=ON \
	    -DENABLE_FUSE:BOOL=$(FUSE) \
	    -DENABLE_CEPH:BOOL=$(CEPH) \
	    -DENABLE_XRDEC:BOOL=$(EC) \
	    -DPIP_OPTIONS="--no-deps --use-pep517 --no-build-isolation --disable-pip-version-check --verbose"

override_dh_auto_build:
	dh_auto_build
	[ "$(BUILD_DOC)" = "FALSE" ] || ( \
	doxygen Doxyfile && \
	sed 's!src=".*/xrootd-logo.png"!src="xrootd-logo.png"!' \
	    -i doxydoc/html/index.html && \
	cp -p docs/images/xrootd-logo.png doxydoc/html )

override_dh_auto_test:
	# Reduce socket path lengths used during tests
	# Tests fail with sockets in the build directory if path is too long
	mktemp -d -p /var/tmp > adminpath
	cp -p tests/XRootD/common.cfg tests/XRootD/common.cfg.orig
	sed "s!all.adminpath .*!all.adminpath $$(cat adminpath)!" \
	    -i obj-$(DEB_HOST_GNU_TYPE)/tests/cluster/common.cfg \
	       tests/XRootD/common.cfg

	touch testfile
	if ( setfattr -n user.testattr -v testvalue testfile ) ; then \
	    dh_auto_test ; \
	else \
	    echo "Extended file attributes not supported by file system" ; \
	    echo "Don't run tests that require them" ; \
	    dh_auto_test -- ARGS+="-E '\
XrdCl::FileCopyTest|\
XrdCl::FileSystemTest.PlugInTest|\
XrdCl::FileSystemTest.ServerQueryTest|\
XrdCl::FileSystemTest.XAttrTest|\
XrdCl::FileTest.XAttrTest|\
XrdCl::LocalFileHandlerTest.XAttrTest|\
XrdCl::ThreadingTest|\
XrdCl::WorkflowTest.CheckpointTest|\
XrdCl::WorkflowTest.XAttrWorkflowTest|\
XrdEc::|\
XRootD::cluster::test|\
XRootD::http::test'" ; \
	fi
	rm testfile

	mv tests/XRootD/common.cfg.orig tests/XRootD/common.cfg
	rm -rf $$(cat adminpath)
	rm adminpath

override_dh_auto_install:
	ln -sf libxrootd-private-dev.install.ec-$(EC) \
	   debian/libxrootd-private-dev.install

	DEB_PYTHON_INSTALL_LAYOUT=deb dh_auto_install

	rm -f debian/tmp/usr/lib/*/libXrdCephPosix.so

	rm -f debian/tmp/usr/bin/xrdshmap

	rm -f debian/tmp/usr/lib/python3/dist-packages/xrootd-*.*-info/direct_url.json

	[ "$(BUILD_DOC)" = "FALSE" ] || ( \
	LD_LIBRARY_PATH=$${LD_LIBRARY_PATH}:$(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH) \
	PYTHONPATH=$(CURDIR)/debian/tmp/usr/lib/python3/dist-packages \
	PYTHONDONTWRITEBYTECODE=1 \
	make -C bindings/python/docs html && \
	mv bindings/python/docs/build/html bindings/python/docs/build/python )

	# Service unit files
	mkdir -p debian/tmp/usr/lib/systemd/system
	install -m 644 packaging/common/xrootd@.service debian/tmp/usr/lib/systemd/system
	install -m 644 packaging/common/xrootd@.socket debian/tmp/usr/lib/systemd/system
	install -m 644 packaging/common/xrdhttp@.socket debian/tmp/usr/lib/systemd/system
	install -m 644 packaging/common/cmsd@.service debian/tmp/usr/lib/systemd/system
	install -m 644 packaging/common/frm_xfrd@.service debian/tmp/usr/lib/systemd/system
	install -m 644 packaging/common/frm_purged@.service debian/tmp/usr/lib/systemd/system
	mkdir -p debian/tmp/usr/lib/tmpfiles.d
	install -m 644 packaging/rhel/xrootd.tmpfiles debian/tmp/usr/lib/tmpfiles.d/xrootd.conf

	# Server config
	mkdir -p debian/tmp/etc/xrootd
	install -m 644 -p packaging/common/xrootd-clustered.cfg \
	    debian/tmp/etc/xrootd/xrootd-clustered.cfg
	install -m 644 -p packaging/common/xrootd-standalone.cfg \
	    debian/tmp/etc/xrootd/xrootd-standalone.cfg
	install -m 644 -p packaging/common/xrootd-filecache-clustered.cfg \
	    debian/tmp/etc/xrootd/xrootd-filecache-clustered.cfg
	install -m 644 -p packaging/common/xrootd-filecache-standalone.cfg \
	    debian/tmp/etc/xrootd/xrootd-filecache-standalone.cfg
	sed 's!/usr/lib64/!!' packaging/common/xrootd-http.cfg > \
	    debian/tmp/etc/xrootd/xrootd-http.cfg

	# Client config
	mkdir -p debian/tmp/etc/xrootd/client.plugins.d
	install -m 644 -p packaging/common/client.conf \
	    debian/tmp/etc/xrootd/client.conf
	sed 's!/usr/lib/!!' packaging/common/client-plugin.conf.example > \
	    debian/tmp/etc/xrootd/client.plugins.d/client-plugin.conf.example
	sed -e 's!/usr/lib64/!!' -e 's!-5!!' packaging/common/recorder.conf > \
	    debian/tmp/etc/xrootd/client.plugins.d/recorder.conf
	sed 's!/usr/lib64/!!' packaging/common/http.client.conf.example > \
	    debian/tmp/etc/xrootd/client.plugins.d/xrdcl-http-plugin.conf

	chmod 644 debian/tmp/usr/share/xrootd/utils/XrdCmsNotify.pm
	sed 's!/usr/bin/env perl!/usr/bin/perl!' -i \
	    debian/tmp/usr/share/xrootd/utils/netchk \
	    debian/tmp/usr/share/xrootd/utils/XrdCmsNotify.pm \
	    debian/tmp/usr/share/xrootd/utils/XrdOlbMonPerf

	sed 's!/usr/bin/env bash!/bin/bash!' -i \
	    debian/tmp/usr/bin/xrootd-config

	mkdir -p debian/tmp/etc/xrootd/config.d

	mkdir -p debian/tmp/var/log/xrootd
	mkdir -p debian/tmp/var/spool/xrootd

	mkdir -p debian/tmp/etc/logrotate.d
	install -m 644 -p packaging/common/xrootd.logrotate \
	    debian/tmp/etc/logrotate.d/xrootd

## xrootd 5.8.0

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -18,6 +18,8 @@
 
 add_subdirectory(XrdTpcTests)
 
+add_subdirectory(XrdPfcTests)
+
 if( BUILD_SCITOKENS )
   add_subdirectory( scitokens )
 endif()
@@ -28,3 +30,4 @@
 
 add_subdirectory( XRootD )
 add_subdirectory( cluster )
+add_subdirectory( stress )

=== src/XrdEc/CMakeLists.txt ===
include( ExternalProject )

#-------------------------------------------------------------------------------
# The XrdEc shared library
#-------------------------------------------------------------------------------

set( XRD_EC_VERSION   1.0.0 )
set( XRD_EC_SOVERSION 1 )

add_library(
  XrdEc
  SHARED
  XrdEcConfig.hh
  XrdEcObjCfg.hh
  XrdEcRedundancyProvider.hh   XrdEcRedundancyProvider.cc 
  XrdEcUtilities.hh            XrdEcUtilities.cc
  XrdEcWrtBuff.hh
  XrdEcThreadPool.hh
  XrdEcStrmWriter.hh           XrdEcStrmWriter.cc
  XrdEcReader.hh               XrdEcReader.cc
)

target_link_libraries(XrdEc PRIVATE XrdCl XrdUtils ${ISAL_LIBRARIES})
target_include_directories(XrdEc PRIVATE ${ISAL_INCLUDE_DIRS})

set_target_properties(
  XrdEc
  PROPERTIES
  VERSION   ${XRD_EC_VERSION}
  SOVERSION ${XRD_EC_SOVERSION} )
  
#------------------------------------------------------------------------------
# Install XrdEc library
#------------------------------------------------------------------------------
install(
  TARGETS XrdEc
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} )

#------------------------------------------------------------------------------
# Install private header files
#------------------------------------------------------------------------------
install(
  FILES
    XrdEcReader.hh
    XrdEcObjCfg.hh
    XrdEcStrmWriter.hh
    XrdEcWrtBuff.hh
    XrdEcThreadPool.hh
    XrdEcUtilities.hh
    XrdEcObjCfg.hh
    XrdEcConfig.hh
    XrdEcRedundancyProvider.hh
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/xrootd/private/XrdEc )

=== debian/changelog ===
xrootd (5.8.0-1) unstable; urgency=medium

  * Update to version 5.8.0
  * Move user/group creation logic to sysusers.d fragment
  * Set HOSTNAME to localhost during testing
  * Set _PYTHON_HOST_PLATFORM for reproducible builds

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Sat, 22 Mar 2025 10:57:27 +0100
